package net.hoo2.auth.vmodem;

import java.io.IOException;
import java.io.PrintWriter;

class Log {

   private String      logfile_;
   private boolean     verbose_;
   private PrintWriter writer_;

   Log (String logfile, boolean verbose) {
      logfile_ = logfile;
      verbose_ = verbose;
   }
   
   boolean open () {
      if (logfile_ != null) {
         try {
            writer_ = new PrintWriter(logfile_);
         }
         catch (IOException exp) {
            System.err.println( "Open log file failed: " + exp.getMessage() );
            return false;
         }
      }
      return true;
   }
   boolean open (String logfile) {
      logfile_ = logfile;
      return open();
   }
   
   boolean close () {
      try {
         if (writer_ != null)
            writer_.close();
      } catch (Exception ex) {
         return false;
      }
      return true;
   }
   
   void write (String line, boolean out) {
      if (logfile_ != null) writer_.println(line);
      if (verbose_ || out)  System.out.println(line);
   }
   
   void write (String line) {
      if (logfile_ != null) writer_.println(line);
      if (verbose_)         System.out.println(line);
   }
   
   void out (String line) {
      if (verbose_)  System.out.println(line);
   }
}
